--[[
PSP eMail and SMS v3 by cools
( Thanks to Soadnation for the Analog Stick Info! )
2:00 PM 11/22/2006
]]--

--Pad and Colors
oldpad = Controls.read()
white = Color.new(255, 255, 255)
black = Color.new(0,0,0)
red = Color.new(255,0,0)

--Dofiles
dofile("danzeffarray.lua")
dofile("netlib.lua")
dofile("bgsave.txt")

--Images
keys = Image.load("./graphics/keys.png")
keys_c = Image.load("./graphics/keys_c.png")
keys_s = Image.load("./graphics/keys_s.png")
keys_s_c = Image.load("./graphics/keys_s_c.png")
nums = Image.load("./graphics/nums.png")
nums_c = Image.load("./graphics/nums_c.png")
nums_s = Image.load("./graphics/nums_s.png")
nums_s_c = Image.load("./graphics/nums_s_c.png")
selectorp = Image.load("selector.png")

--Background Mini Images
mbg = {}
for q = 1, 12 do
mbg[q] = Image.load("Backgrounds/background" .. q .. "mini.png")
end

--Background Authors
authors = {
	"chrisk",
	"XSonic",
	"Siouxsie",
	"chrisk",
	"chrsik",
	"Siouxsie",
	"thethingexe",
	"Deanaw22",
	"chrisk",
	"chrisk",
	"kozine",
	"XSonic"
}

--Main Variables
keyopt = 1
selectpad = standletters
stringnum = 1
danzeffopt = keys_s
selector = 5
innerChoice = 1
optvalue = 1
wifiopt = 1

--Input Variables
to = ""
from = ""
subject = ""
message = ""

messagetext = {}

--Background Table
backgrounds = {}
for i = 1, 12 do
table.insert(backgrounds,i,i)
end
table.insert(backgrounds,13,"Random")

--Background
if bgopt == "" then bgopt = 13 end
if backgrounds[bgopt] == "Random" then
math.randomseed(os.time())
bgr = math.random(10)
background = Image.load("Backgrounds/background"..bgr..".png")
dofile("Backgrounds/background"..bgr..".lua")
else background = Image.load("Backgrounds/background"..bgopt..".png")
dofile("Backgrounds/background"..bgopt..".lua")
end

--Invert Text Color
color = background:pixel(x_to,y_to)
colors = color:colors()
newcolor = Color.new(255 - colors.r, 255 - colors.g, 255 - colors.b)
if bgopt == 7 then newcolor = Color.new(255,255,255) end

--Invert Text Color (diff section of screen...)
color = background:pixel(3,262)
colors = color:colors()
bottom = Color.new(255 - colors.r, 255 - colors.g, 255 - colors.b)
-- - - - - - - - - - - - - - - - - - - - - -
--Displays the boxes in the correct places and other...
function danzeff()

	--Up/Down/Left/Right
		--Right
	if analogX > 32 and analogY > -40 and analogY < 40 then
		screen:blit(106,53,danzeffopt,128,64,63,63)
		stringnum = 6
	end
		--Left
	if analogX < -32 and analogY > -40 and analogY < 40 then
		screen:blit(0,53,danzeffopt,0,64,63,63)
		stringnum = 4
	end
		--Down
	if analogY > 32 and analogX < 40 and analogX > -40 then
		screen:blit(53,105,danzeffopt,64,128,63,63)
		stringnum = 8
	end
		--Up
	if analogY < -32 and analogX < 40 and analogX >-40 then
		screen:blit(53,0,danzeffopt,64,0,63,63)
		stringnum = 2
	end
		--Center
	if analogY > -32 and analogY <32 and analogX < 32 and analogX > -32 then
		screen:blit(53,53,danzeffopt,64,64,63,63)
		stringnum = 5
	end

	--Diagnals
		--Up/Right
	if analogY < -32 and analogX > 40 then
		screen:blit(106,0,danzeffopt,128,0,63,63)
		stringnum = 3
	end
		--Up/Left
	if analogY < -32 and analogX < -40 then
		screen:blit(0,0,danzeffopt,0,0,63,63)
		stringnum = 1
	end
		--Down/Right
	if analogY > 32 and analogX > 40 then
		screen:blit(106,105,danzeffopt,128,128,63,63)
		stringnum = 9
	end
		--Down/Left
	if analogY > 32 and analogX < -40 then
		screen:blit(0,105,danzeffopt,0,128,63,63)
		stringnum = 7
	end
end

-- - - - - - - - - - - - - - - - - - - - - -
--Returns whether two controller buttons are the same

function compareControllers(controller1, controller2) -- lua adaptation
	if (controller1:square() ~= controller2:square()) then
		return false
	elseif (controller1:triangle() ~= controller2:triangle()) then
		return false
	elseif (controller1:circle() ~= controller2:circle()) then
		return false
	elseif (controller1:cross() ~= controller2:cross()) then
		return false
	elseif (controller1:up() ~= controller2:up()) then
		return false
	elseif (controller1:down() ~= controller2:down()) then
		return false
	elseif (controller1:left() ~= controller2:left()) then
		return false
	elseif (controller1:right() ~= controller2:right()) then
		return false
	elseif (controller1:start() ~= controller2:start()) then
		return false
	elseif (controller1:select() ~= controller2:select()) then
		return false
	elseif (controller1:l() ~= controller2:l()) then
		return false
	elseif (controller1:r() ~= controller2:r()) then
		return false
	end
	return true
end

-- - - - - - - - - - - - - - - - - - - - - -
--Determines what button has been pressed and returns the letter

function Input(pad)

pressed = 1

if (not compareControllers(oldpad, pad)) then
   if pad:cross() or pad:circle() or pad:triangle() or pad:square() then

      if (pad:triangle()) then innerChoice = 1
         elseif pad:square() then innerChoice = 2
         elseif pad:cross() then innerChoice = 3
         elseif pad:circle() then innerChoice = 4
      end
   
pressed = string.byte(string.sub(selectpad[stringnum], innerChoice, innerChoice))

   end
end

oldpad = pad

return pressed
end
-- - - - - - - - - - - - - - - - - - - - - -
--Delays in Milliseconds
function delay( milli )
	vs=math.floor(milli/60)
	screen.waitVblankStart( vs )
end

-- - - - - - - - - - - - - - - - - - - - - -
--To
function to_input()
if (textString ~= 0 and textString ~= 1 and textString ~= 2) then
	if (textString == 8 or textString == string.byte("\010")) then 
		to = string.sub(to,1,(string.len(to)-1))
	elseif (textString == 13) then 
		to = ""
	elseif (textString == 4) then
		return 
	else
		to = to .. string.char(textString)
	end
end
end
-- - - - - - - - - - - - - - - - - - - - - -
--From
function from_input()
if (textString ~= 0 and textString ~= 1 and textString ~= 2) then
	if (textString == 8 or textString == string.byte("\010")) then 
		from = string.sub(from,1,(string.len(from)-1)) 
	elseif (textString == 13) then 
		from = ""
	elseif (textString == 4) then
		return 
	else
		from = from .. string.char(textString)
	end
end
end
-- - - - - - - - - - - - - - - - - - - - - -
--Subject
function subject_input()
if (textString ~= 0 and textString ~= 1 and textString ~= 2) then
	if (textString == 8 or textString == string.byte("\010")) then 
		subject = string.sub(subject,1,(string.len(subject)-1)) 
	elseif (textString == 13) then 
		subject = ""
	elseif (textString == 4) then
		return 
	else
		subject = subject .. string.char(textString)
	end
end
end
-- - - - - - - - - - - - - - - - - - - - - -
--Message
function message_input()
if (textString ~= 0 and textString ~= 1 and textString ~= 2) then
	if (textString == 8 or textString == string.byte("\010")) then 
		message = string.sub(message,1,(string.len(message)-1)) 
	elseif (textString == 13) then 
		message = ""
	elseif (textString == 4) then
		return 
	else
		message = message .. string.char(textString)
	end
	
end
end
-- - - - - - - - - - - - - - - - - - - - - -
--Clear Ram
function clearram()
	keys = nil
	keys_c = nil
	keys_s = nil
	keys_s_c = nil
	nums = nil
	nums_c = nil
	nums_s = nil
	nums_s_c = nil
	selectorp = nil
	background = nil
	collectgarbage()
end
-- - - - - - - - - - - - - - - - - - - - - -
--Options
function Options()
while white == Color.new(255, 255, 255) do
	if optvalue == 1 then
		sendopt = 1
		oldpad = Controls.read()
		while optvalue == 1 do
			Wlan.init()
			configs = Wlan.getConnectionConfigs()
			screen:fillRect(110,60,260,152,black)
			screen:print(120,70,"Send eMail",white)
			screen:print(120,80,"Send SMS",white)
			screen:print(120,90,"Send text2phone",white)
			screen:print(120,100,"Send Verizon Text Message",white)
			screen:print(120,180,"Select Wifi Connection",white)
			screen:print(120,190,"Selected Wifi:" .. configs[wifiopt],white)
			pad = Controls.read()
			if pad:up() then sendopt = sendopt - 1 delay(500) end
			if pad:down() then sendopt = sendopt + 1 delay(500) end
			if pad:triangle() then Wlan.term() break end
			if pad:square() and oldpad:square() ~= pad:square() then optvalue = 2 end
			if sendopt < 1 then sendopt = 5 end
			if sendopt > 5 then sendopt = 1 end
			if sendopt == 1 then
				screen:print(120,70,"Send eMail",red)
				if to == "" or from == "" or subject == "" or message == "" then
					screen:print(120,120,"Fill in all Fields, Can't Send!",white)
				end
				if pad:cross() then
					Wlan.useConnectionConfig(wifiopt)
					netmail(to,from,subject,message) Wlan.term() break
				end
			end
	
			if sendopt == 2 then
				screen:print(120,80,"Send SMS",red)
					if to == "" then
						screen:print(120,120,"To unfilled, Can't Send!",white)
					end
					if from == "" then
						screen:print(120,130,"From unfilled, Can't Send!",white)
					end
					if message == "" then
						screen:print(120,140,"Message unfilled, Can't Send!",white)
					end
					if string.len(to) ~= 10 and string.find(to,"%d") ~= "%d" then
						screen:print(120,150,"To Must be 10 Digits Long!",white)
					end
				if pad:cross() then
					Wlan.useConnectionConfig(wifiopt)
					netsms(to,message,from) Wlan.term() break
				end
			end
	
			if sendopt == 3 then
				screen:print(120,90,"Send text2phone",red)
					if to == "" then
						screen:print(120,120,"Fill in To field, Can't Send!",white)
					end
					if message == "" then
						screen:print(120,130,"Message unfilled, Can't Send!",white)
					end
				if pad:cross() then
					Wlan.useConnectionConfig(wifiopt)
					text2phone(to,message) Wlan.term() break
				end
			end
	
			if sendopt == 4 then
				screen:print(120,100,"Send Verizon Text Message",red)
				if to == ""then
					screen:print(120,120,"To unfilled, Can't Send!",white)
				end
				if from == "" then
					screen:print(120,130,"From unfilled, Can't Send!",white)
				end
				if message == "" then
					screen:print(120,140,"Message unfilled, Can't Send!",white)
				end
				if string.len(to) ~= 10 and string.find(to,"%d") ~= "%d" then
					screen:print(120,150,"To Must be 10 Digits Long!",white)
				end
				if subject ~="" then
					screen:print(120,160,"Subject Must NOT be Filled!",white)
				end
				if (string.len(message)+string.len(from)+string.len(to)) > 160 then
					screen:print(120,170,"Total Length needs to be less than 160 chars",white)
				end
				if pad:cross() then
					Wlan.useConnectionConfig(wifiopt)
					netmail(to.."@vtext.com",from,subject,message) Wlan.term() break
				end
			end

			if sendopt == 5 then
				screen:print(120,180,"Select Wifi Connection",red)
				if Controls.read():right() and wifiopt < table.getn(configs) then wifiopt = wifiopt + 1 end
				if Controls.read():left() then if wifiopt - 1 == 0 then wifiopt = 1 else wifiopt = wifiopt - 1 end end
			end

			screen.waitVblankStart()
			screen.flip()
			oldpad = pad
		end
	end
	if optvalue == 2 then
		Wlan.term()
		bkopt = 1
		oldpad = Controls.read()
		while optvalue == 2 do
			pad = Controls.read()
			screen:fillRect(110,60,260,152,black)
			screen:print(120,70,"Backgrounds",white)
			screen:print(120,90,"Change Background:",white)
			screen:print(120,100,"Value: "..backgrounds[bgopt],white)
			screen:print(120,120,"Save Current Background",white)
			if bgopt ~= 13 then
				screen:blit(192,135,mbg[bgopt])
				screen:print(120,197,"Author: "..authors[bgopt],white)
			end
			if pad:up() then bkopt = 1 end
			if pad:down() then bkopt = 2 end
			if pad:square() and oldpad:square() ~= pad:square() then optvalue = 1 end
			if bkopt == 1 then
				screen:print(120,90,"Change Background:",red)
				if pad:right() then bgopt = bgopt + 1 delay(500) end
				if pad:left() then bgopt = bgopt - 1 delay(500) end
				if bgopt < 1 then bgopt = 13
				elseif bgopt > 13 then bgopt = 1 end
			end
			if bkopt == 2 then
				screen:print(120,120,"Save Current Background",red)
				if pad:cross() then
					file = io.open("bgsave.txt","w")
					file:write("bgopt = "..bgopt)
					file:close()
				end
			end
			screen.waitVblankStart()
			screen.flip()
			if pad:triangle() then Wlan.term() break end
			oldpad = pad
		end
	end
if pad:triangle() then 
	if bgopt ~= 13 then
		dofile("Backgrounds/background"..bgopt..".lua")
		background = nil
		collectgarbage()
		background = Image.load("Backgrounds/background"..bgopt..".png")
		color = background:pixel(x_to,y_to) colors = color:colors()
		newcolor = Color.new(255 - colors.r, 255 - colors.g, 255 - colors.b)
		if bgopt == 7 then newcolor = Color.new(255,255,255) end
		color = background:pixel(3,262)
		colors = color:colors()
		bottom = Color.new(255 - colors.r, 255 - colors.g, 255 - colors.b)
	end break end
end
end

-- - - - - - - - - - - - - - - - - - - - - -
while true do
	screen:blit(0,0,background)
	screen:blit(10,10,keys)
	screen:print(3,262,"Message Length: "..string.len(message).." Total Length: "..(string.len(message)+string.len(from)+string.len(to)),bottom)
	pad = Controls.read()
	analogX = pad:analogX()
	analogY = pad:analogY()
	textString = Input(Controls.read())
	if pad:start() then
		Wlan.term()
		clearram()
		break
	end

	messagetext[1] = string.sub(message, 1, max_message)
	
	for l = 2, max_line do
		messagetext[l] = string.sub(message, max_message * (l-1), max_message * (l-1) + (max_message -1))
	end
	
if selector == 1 then screen:blit(selector_x_to,selector_y_to,selectorp) to_input() end
if selector == 2 then screen:blit(selector_x_from,selector_y_from,selectorp) from_input() end
if selector == 3 then screen:blit(selector_x_subject,selector_y_subject,selectorp) subject_input() end
if selector == 4 then screen:blit(selector_x_message,selector_y_message,selectorp) message_input() end

if pad:down() then selector=selector + 1 delay(500) end
if pad:up() then selector=selector - 1 delay(500) end
if selector > 4 then selector = 1 end
if selector < 1 then selector = 4 end

if keyopt == 1 then screen:blit(10,10,keys) danzeffopt = keys_s selectpad = standletters end
if keyopt == 2 then screen:blit(10,10,keys_c) danzeffopt = keys_s_c selectpad = capletters end
if keyopt == 3 then screen:blit(10,10,nums) danzeffopt = nums_s selectpad = numbers end
if keyopt == 4 then screen:blit(10,10,nums_c) danzeffopt = nums_s_c selectpad = specialchar end

if pad:r() then keyopt = keyopt + 1 delay(500) end
if pad:l() then keyopt = keyopt - 1 delay(500) end
if keyopt > 4 then keyopt = 1 end
if keyopt < 1 then keyopt = 4 end

danzeff()

screen:print(x_to,y_to,to,newcolor)
screen:print(x_from,y_from,from,newcolor)
screen:print(x_subject,y_subject,subject,newcolor)

for v = 1, table.getn(messagetext) do
	screen:print(x_message, y_message + (10 * v - 10), messagetext[v], newcolor)
end

if pad:select() then
	Options()
end

screen.waitVblankStart()
screen.flip()
end